



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>JAVA基础—线程池</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">JAVA基础—线程池</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-23 12:54:29 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p><a href="https://www.cnblogs.com/ssskkk/p/9277588.html" rel="external nofollow noreferrer">推荐文章java多线程基础</a></p>
<h3>线程池概述</h3>
<p>为什么要使用线程池</p>
<p>　　1.服务器创建和销毁工作线程的开销很大</p>
<p>　　2.如果频繁的创建和销毁线程会导致频繁的切换线程，因为一个线程被销毁后，必然要把CPU转让给另一个已经就绪的线程</p>
<p>　　3.除了创建和销毁线程的开销之外，活动线程也销毁系统资源。每个线程本身会占用一定的内存(每个线程需要大约1MB内存)，如果创建大量工作线程，它们消耗大量内存，可能会导致系统的内存空间不足。</p>
<p>线程池概念</p>
<p>线程池为线程生命周期开销问题和系统资源不足问题提供了解决方案。线程池中预先创建了一些工作线程，它们不断的从工作队列中取出任务，然后执行该任务。当工作线程执行完一个任务时，就会继续执行工作队列中的下一个任务。</p>
<p>线程池的特点：</p>
<p>　　1.减少了创建和销毁线程的次数，每个工作线程都可以一直被重用，能执行多个任务</p>
<p>　　2.可以根据系统的承载能力，方便的调整线程池中的线程数目，防止因为消耗过量的系统资源而导致系统崩溃</p>
<h3>JDK类库提供的线程池</h3>
<p><a href="http://tool.oschina.net/uploads/apidocs/jdk-zh/java/util/concurrent/Executor.html" rel="external nofollow noreferrer">Executor</a>接口表示线程池，它的<a href="http://tool.oschina.net/uploads/apidocs/jdk-zh/java/util/concurrent/Executor.html#execute(java.lang.Runnable)" rel="external nofollow noreferrer">execute(Runnable task)</a>方法用来执行Runnable类型的任务。</p>
<p>Executor的子接口<a href="http://tool.oschina.net/uploads/apidocs/jdk-zh/java/util/concurrent/ExecutorService.html" rel="external nofollow noreferrer">ExecutorService</a>中声明了管理线程池的一些方法，比如关闭线程池的shutdown()方法等。</p>
<p><a href="http://tool.oschina.net/uploads/apidocs/jdk-zh/java/util/concurrent/Executors.html" rel="external nofollow noreferrer">Excutors</a>类中包含一些静态方法，他们负责生成各种类型的线程池ExecutorService实例</p>
<div>
<pre class="prettyprint linenums">public class Machine implements Runnable{

    private int id;

    public Machine(int id) {<br />
        super();<br />
        this.id = id;<br />
    }

    @Override<br />
    public void run() {<br />
        for(int a=0;a&lt;10;a++){<br />
            System.out.println("当前线程："+Thread.currentThread().getName()+" 当前Machine"+id+" :a="+a);<br />
            Thread.yield();<br />
        }<br />
    }

    public static void main(String[] args) throws Exception {<br />
        ExecutorService service = Executors.newFixedThreadPool(2);<br />
        for(int i=0;i&lt;5;i++){<br />
            service.submit(new Machine(i));//像线程池提交五个Machine任务<br />
        }<br />
        System.out.println("任务提交结束");<br />
        service.shutdown();<br />
        System.out.println("等任务提交任务完成后，服务会关闭");<br />
    }<br />
}</pre>
</div>
<p><strong>也可以通过线程池的构造方法，用给定的初始参数和默认的线程工厂创建线程池 推荐(比上面的创建方式更明确的线程池的运行规则，避免资源耗尽的风险)。&nbsp;</strong></p>
<pre class="prettyprint linenums">public <a href="http://tool.oschina.net/uploads/apidocs/jdk-zh/java/util/concurrent/ThreadPoolExecutor.html" rel="external nofollow noreferrer">ThreadPoolExecutor</a>(int&nbsp;corePoolSize,<br />
                          int&nbsp;maximumPoolSize,<br />
                          long&nbsp;keepAliveTime,<br />
                          <a href="http://tool.oschina.net/uploads/apidocs/jdk-zh/java/util/concurrent/TimeUnit.html" rel="external nofollow noreferrer">TimeUnit</a>&nbsp;unit,<br />
                          <a href="http://tool.oschina.net/uploads/apidocs/jdk-zh/java/util/concurrent/BlockingQueue.html" rel="external nofollow noreferrer">BlockingQueue</a>&lt;<a href="http://tool.oschina.net/uploads/apidocs/jdk-zh/java/lang/Runnable.html" rel="external nofollow noreferrer">Runnable</a>&gt;&nbsp;workQueue,<br />
                          <a href="http://tool.oschina.net/uploads/apidocs/jdk-zh/java/util/concurrent/RejectedExecutionHandler.html" rel="external nofollow noreferrer">RejectedExecutionHandler</a>&nbsp;handler)</pre>
<dl>
<dd>
<dl>
<dt>参数：</dt>
<dd><code>corePoolSize</code>&nbsp;-</dd>
<dd>&nbsp; &nbsp; &nbsp;表示常驻核心线程数 ，如果运行的线程少于 corePoolSize，则创建新线程来处理请求，即使其他辅助线程是空闲的，如果线程池的线程数小于核心线程数 即使执行完毕也不会销毁。</dd>
<dd><strong><code>maximumPoolSize</code>&nbsp;-&nbsp;</strong></dd>
<dd><strong>&nbsp; &nbsp; &nbsp;池中允许的最大线程数。如果执行的线程数大于核心线程数时，需要借助第五个参数的帮助，缓存在队列中</strong></dd>
<dd><strong>&nbsp; &nbsp; &nbsp;如果运行的线程多于 corePoolSize 而少于 maximumPoolSize，则仅当队列满时才创建新线程。</strong></dd>
<dd>如果设置的 corePoolSize 和 maximumPoolSize 相同，则创建了固定大小的线程池。</dd>
<dd><code>keepAliveTime</code>&nbsp;-&nbsp;当线程数大于核心时，此为终止前多余的空闲线程等待新任务的最长时间。(<strong>呆多长时间之后 没有任务传给它，它就会消失</strong>)</dd>
<dd><code>unit</code>&nbsp;- keepAliveTime&nbsp;参数的时间单位。</dd>
<dd>如果池中当前有多于 corePoolSize 的线程，则这些多出的线程在空闲时间超过 keepAliveTime 时将会终止（参见&nbsp;<a href="http://tool.oschina.net/uploads/apidocs/jdk-zh/java/util/concurrent/ThreadPoolExecutor.html#getKeepAliveTime(java.util.concurrent.TimeUnit)" rel="external nofollow noreferrer"><code>getKeepAliveTime(java.util.concurrent.TimeUnit)</code></a>）</dd>
<dd><strong><code>workQueue</code>&nbsp;- 表示缓存队列(装任务的容器)</strong></dd>
<dd>
<p>　　如果运行的线程少于 corePoolSize，则 Executor 始终首选添加新的线程，而不进行排队。<br />　　如果运行的线程等于或多于 corePoolSize，则 Executor 始终首选将请求加入队列，而不添加新的线程。<br />　　如果无法将请求加入队列，则创建新的线程，除非创建此线程超出 maximumPoolSize，在这种情况下，任务将被拒绝。</p>
</dd>
<dd><strong><code>handler</code></strong></dd>
<dd>&nbsp; &nbsp; &nbsp; &nbsp; 由于超出线程范围和队列容量而使执行被阻塞时所使用的处理程序(所有线程都忙着 即线程池忙 并且任务队列满了)。</dd>
<dd><a href="https://blog.csdn.net/huangshanchun/article/details/78567501" rel="external nofollow noreferrer">思考：线程池达到最大线程数量，缓冲队列满时，多余的线程会被丢弃，这是不想看到的，可不可以将缓冲队列设置无限大？如果这么做对线程池有何影响？</a></dd>
<dd><strong>任务队列+最大线程数=线程池总共能处理的任务</strong></dd>
</dl>
</dd>
</dl>
<h3>自己模拟一个线程池</h3>
<div>
<div>
<pre class="prettyprint linenums">package javaee.net.cn.thread;

import java.util.LinkedList;

/**<br />
 * @Modified By:自定义线程池的实现<br />
 */<br />
public class ThreadPool extends ThreadGroup {

    private boolean isClosed = false;//线程池是否关闭<br />
    private LinkedList&lt;Runnable&gt; workQuee;//表示工作队列<br />
    private static int threadPoolID;//表示线程池ID<br />
    private int workThreadID;//表示工作线程池ID

    public ThreadPool(int poolSize) {<br />
        //poolSize表示线程池中工作线程的数目<br />
        //每一次的初始化，线程池ID都会自动增加<br />
        super("ThreadPool-" + (threadPoolID++));<br />
        //设置为守护线程<br />
        setDaemon(true);<br />
        workQuee = new LinkedList&lt;&gt;();//创建工作队列<br />
        for (int i = 0; i &lt; poolSize; i++) {<br />
            new WorkThread().start();<br />
        }<br />
    }

    /**<br />
     * 向工作队列中添加一个新的任务，让工作线程去执行<br />
     *<br />
     * @param task<br />
     */<br />
    public synchronized void execute(Runnable task) {<br />
        if (isClosed) {<br />
            //线程池关闭，则抛出如下的异常<br />
            throw new IllegalStateException();<br />
        }<br />
        if (task != null) {<br />
            workQuee.add(task);<br />
            notify();//唤醒正在等待获取任务的工作线程getTask();<br />
        }<br />
    }

    /**<br />
     * 从工作队列中取出一个线程，让线程执行任务<br />
     *<br />
     * @return<br />
     * @throws InterruptedException<br />
     */<br />
    public synchronized Runnable getTask() throws InterruptedException {<br />
        while (workQuee.size() == 0) {<br />
            //当工作队列中的线程为0时，如果线程池关闭，则返回null.负责，等待任务<br />
            if (isClosed) {<br />
                return null;<br />
            } else {<br />
                wait();<br />
            }<br />
        }<br />
        return workQuee.removeFirst();//从工作队列中弹出第一个元素<br />
    }

    /**<br />
     * 关闭线程池<br />
     */<br />
    public synchronized void closed() {<br />
        //线程池没有关闭<br />
        if (!isClosed) {<br />
            isClosed = true;<br />
            workQuee.clear();//清除工作队列<br />
            interrupt();//中断所有的线程<br />
        }<br />
    }

    /**<br />
     * 等在工作线程将若有的任务执行完毕<br />
     */<br />
    public void join() {<br />
        synchronized (this) {<br />
            isClosed = true;<br />
            notifyAll();//唤醒所有的等待任务的工作线程<br />
        }<br />
        //activeCount() 返回此线程组中活动线程的估计数。 来自ThreadGroup<br />
        Thread[] threads = new Thread[activeCount()];<br />
        // enumerate[list] 把此线程组及其子组中的所有活动线程复制到指定数组中。<br />
        int count = enumerate(threads);//返回所有的活着的线程数量<br />
        for (int i = 0; i &lt; count; i++) {<br />
            try {<br />
                threads[i].join();//等待所有的活动的工作宣称的结束<br />
            } catch (InterruptedException e) {<br />
                e.printStackTrace();<br />
            }<br />
        }<br />
    }

    /**<br />
     * 内部类，创建的工作线程对象<br />
     */<br />
    private class WorkThread extends Thread {<br />
        public WorkThread() {<br />
            super(ThreadPool.this, "WorkThread-" + workThreadID++);<br />
        }

        @Override public void run() {<br />
            //线程没有中断<br />
            while (!isInterrupted()) {<br />
                Runnable task = null;<br />
                try {<br />
                    task = getTask();//获取任务<br />
                } catch (InterruptedException e) {<br />
                    e.printStackTrace();<br />
                }<br />
                if (task == null) {<br />
                    return;<br />
                }<br />
                try {<br />
                    task.run();//运行任务<br />
                } catch (Throwable t) {<br />
                    t.printStackTrace();<br />
                }

            }<br />
        }<br />
    }<br />
}</pre>
</div>
</div>
<p>　　在ThreadPool类中定义一个<a href="http://tool.oschina.net/uploads/apidocs/jdk-zh/java/util/LinkedList.html" rel="external nofollow noreferrer">LinkedList</a>类型的workQueue成员变量，<strong>它表示工作队列，用来存放线程池要执行的任务，</strong>每个任务都是Runnable实例。</p>
<p>　　由ThreadPool来执行任务的程序 只要调用ThreadPool类的excute(Runnable task)方法，就能像线程池提交任务</p>
<p>　<strong>　在线程池的excute()方法中，先判断线程池是否已经关闭。如果线程池已经关闭就不在接收任务，否则就把任务加入到工作队列中，并且唤醒正在等待任务的工作线程(<a href="http://tool.oschina.net/uploads/apidocs/jdk-zh/java/lang/Object.html#notify()" rel="external nofollow noreferrer">notify()方法</a>)。</strong></p>
<p>　　在ThreadPool类的构造方法中，会创建并启动若干个工作线程，工作线程的数目由构造方法的参数poolSize决定。WorkThread表示工作线程，它是ThreadPool类的内部类。</p>
<p>　　工作线程从工作队列中取出一个任务，接着执行该任务，然后从工作队列中取出下一个任务并执行它，如此反复。</p>
<p>工作线程从工作队列中取任务的操作是由ThreadPool类的getTask()方法实现的，它的处理逻辑如下</p>
<ul><li>如果队列的线程池已经关闭，就返回null，表示已经没有任务可以执行了。</li>
<li>如果队列为空，并且线程池没有关闭，那就在此等待，直到其他线程将其唤醒或者中断。</li>
<li>如果队列中有任务，就取出第一个任务并将其返回</li></ul>
<p>线程池的join()和close()方法都可用来关闭线程池，join()方法确保关闭线程池之前，工作线程把队列中的所有任务都执行完。而close()方法时立即清空队列，并且中断所有的工作线程</p>
<p>ThreadPool类是<a href="http://tool.oschina.net/uploads/apidocs/jdk-zh/java/lang/ThreadGroup.html" rel="external nofollow noreferrer">ThreadGroup</a>类的子类。ThreadGroup表示线程组，它提供了管理线程组中线程的方法，列如<a href="http://tool.oschina.net/uploads/apidocs/jdk-zh/java/lang/ThreadGroup.html#interrupt()" rel="external nofollow noreferrer">interrupt()</a>方法相当于调用线程组中所有活着的线程的interrupt()方法。线程池中所有工作线程都加入到当前ThreadPool对象表示的线程组中。</p>
<p>ThreadPool类在close()方法中调用了iterrupt()方法。</p>
<div>
<pre class="prettyprint linenums">    /**<br />
     * 关闭线程池<br />
     */<br />
    public synchronized void closed() {<br />
        //线程池没有关闭<br />
        if (!isClosed) {<br />
            isClosed = true;<br />
            workQuee.clear();//清除工作队列<br />
            interrupt();//中断所有的线程<br />
        }<br />
    }</pre>
</div>
<p>以上interrupt()方法用于中断所有的工作线程。iterrupt()方法会对工作线程造成以下影响:</p>
<ul><li>如果一个工作线程正在ThreadPool的getTask()方法中因为执行<a href="http://tool.oschina.net/uploads/apidocs/jdk-zh/java/lang/Object.html#wait()" rel="external nofollow noreferrer">wait()</a>方法而阻塞，则会抛出InterruptedException</li>
<li>如果此时一个工作线程正在执行一个任务，并且这个任务不会被阻塞，那么这个工作线程会正常执行完任务，但是在执行下一轮while(!isInterrupted()){...}循环时，由于<a href="http://tool.oschina.net/uploads/apidocs/jdk-zh/java/lang/ThreadGroup.html#interrupt()" rel="external nofollow noreferrer">isInterrupted()</a>会返还true 因此会退出while循环</li></ul>
<h3>运行测试线程池</h3>
<div>
<div>
<pre class="prettyprint linenums">package javaee.net.cn.thread;

/**<br />
 * @Modified By:线程池测试<br />
 */<br />
public class ThreadPoolTester {

    public static void main(String[] args) {<br />
        if (args.length != 2) {<br />
            System.out.println(<br />
                    "用法: java ThreadPoolTest numTasks poolSize");<br />
            System.out.println(<br />
                    "  numTasks - integer: 任务的数目");<br />
            System.out.println(<br />
                    "  numThreads - integer: 线程池中的线程数目");<br />
            return;<br />
        }<br />
        int numTasks = Integer.parseInt(args[0]);<br />
        int poolSize = Integer.parseInt(args[1]);

        ThreadPool threadPool = new ThreadPool(poolSize);  //创建线程池

        // 运行任务<br />
        for (int i = 0; i &lt; numTasks; i++)<br />
            threadPool.execute(createTask(i));

        threadPool.join();  //等待工作线程完成所有的任务<br />
        // threadPool.close(); //关闭线程池<br />
    }//#main()

    /**<br />
     * 定义了一个简单的任务(打印ID)<br />
     */<br />
    private static Runnable createTask(final int taskID) {<br />
        return new Runnable() {<br />
            public void run() {<br />
                System.out.println("Task " + taskID + ": start");<br />
                try {<br />
                    Thread.sleep(500);  //增加执行一个任务的时间<br />
                } catch (InterruptedException ex) {<br />
                }<br />
                System.out.println("Task " + taskID + ": end");<br />
            }<br />
        };<br />
    }<br />
}</pre>
</div>
</div>
<p>ThreadPool threadPool = new ThreadPool(poolSize); //创建线程池</p>
<p>创建线程池的构造方法中，初始化所有工作线程，并通过.start()方法启动所有线程。</p>
<p>此处注意 while 如果线程没有被终止 就会一直执行如下代码(获取任务)。<a href="https://www.cnblogs.com/ssskkk/p/9678471.html" rel="external nofollow noreferrer">这也是和数据库连接池不同的地方</a></p>
<p>线程池中的线程使用完成之后不需要做任何处理(不需要像连接池一样放回池子里)</p>
<p>通过下面的getTask()方法&nbsp;如果workQueue为空，就阻塞等待到workQueue有任务。</p>
<div>
<pre class="prettyprint linenums">            //线程没有中断<br />
           <strong> while (!</strong><strong>isInterrupted()) {</strong><br />
                Runnable task = null;<br />
                try {<br />
                    task = getTask();//获取任务<br />
                } catch (InterruptedException e) {<br />
                    e.printStackTrace();<br />
                }<br />
                if (task == null) {<br />
                    return;<br />
                }<br />
                try {<br />
                    task.run();//运行任务<br />
                } catch (Throwable t) {<br />
                    t.printStackTrace();<br />
                }

            }</pre>
</div>
<p>通过下面的getTask()方法得知，初始化所有工作线程的时候，工作队列是空的，然后所有的线程都wait()住了，不会往下执行removeFirst()方法</p>
<div>
<pre class="prettyprint linenums">    public synchronized Runnable getTask() throws InterruptedException {<br />
        while (workQuee.size() == 0) {<br />
            //当工作队列中的线程为0时，如果线程池关闭，则返回null.否则，等待任务<br />
            if (isClosed) {<br />
                return null;<br />
            } else {<br />
                <strong>wait();</strong><br />
            }<br />
        }<br />
        return workQuee.removeFirst();//从工作队列中弹出第一个元素<br />
    }</pre>
</div>
<p>一直到exectue方法，往工作队列里面添加任务，并且手动notify()</p>
<div>
<pre class="prettyprint linenums">    public synchronized void execute(Runnable task) {<br />
        if (isClosed) {<br />
            //线程池关闭，则抛出如下的异常<br />
            throw new IllegalStateException();<br />
        }<br />
        if (task != null) {<br />
            workQuee.add(task);<br />
            notify();//唤醒正在等待获取任务的工作线程getTask();<br />
        }<br />
    }</pre>
</div>
<p>注意:execute()方法中的&nbsp;workQuee.add(task)代码&nbsp;和 getTask()方法中的workQuee.removeFirst() 对应.</p>
<h3>使用线程池的注意事项</h3>
<p>1.死锁</p>
<p>任何多线程程序都有死锁的风险。造成死锁最简单的情形是，线程A持有对象X的锁，并且在等待对象Y的锁，而线程B持有对象Y的锁，并且在等待对象X的锁。</p>
<p>线程A和线程B都不能释放自己持有的锁，并且等待对方的锁，这样就导致两个线程永远等待下去，死锁就这样产生了。</p>
<p><strong>虽然任何多线程都有死锁的风险，但是线程池还会导致另外一种死锁。</strong></p>
<p>在这种情形下，<strong>假设线程池中的所有工作线程</strong>，都在执行各自任务时被阻塞，它们<strong>都在等待</strong>某个任务A的执行结果，而任务A仍在工作队列中，由于没有空闲线程，使得任务A一直不能执行。</p>
<p>这使得线程池中的所有工作线程都永远阻塞下去，死锁就这样产生了。</p>
<p>2.并发错误</p>
<p>线程池的工作队列依靠<strong>wait()和notify()</strong>方法来使得工作线程及时取得任务，但这两个方法都难于使用。如果编码不正确，可能会丢失通知，导致工作线程一直保持空闲状态，无视工作队列中需要处理的任务。</p>
<p>3.线程泄漏</p>
<p>工作线程在执行一个任务时被阻塞，如果等待用户的输入数据，但是由于用户一直不输入数据(外部原因)，导致这个工作线程一直被阻塞。这样的工作线程名存实亡，它实际上不执行任何任务了。</p>
<p>加入线程池中的所有工作线程都处于这样的阻塞状态。那么线程池就无法处理新加入的任务了。</p>
<p>4.和ThreadLocal使用产生脏数据</p>
<p>由于线程池会复用Thread对象，那么与Thread绑定的类的静态属性ThreadLocal变量也会被重用。解决方法就是:在每次用完ThreadLocal时，必须要及时调用remove()方法进行清理。</p>
<h3>使用线程池的原则</h3>
<p>上面提到了线程池所带来的风险，所以使用线程池时，需要遵循以下原则。</p>
<p>1.如果任务A在执行过程中需要同步等待任务B的执行结果，那么任务A不适合加到线程池的工作队列中。</p>
<p>如果把像任务A一样的需要等待其他任务执行结果的任务加入到工作队列中，可能会导致线程池的死锁</p>
<p>2.如果执行某个任务可能会阻塞，并且是长时间阻塞，则应该设置超时时间，避免工作线程永久阻塞下去导致线程池的泄漏。</p>
<p>Tip: Eclipse调试多线程的时候可能会有问题(debug的顺序未必是真正的执行顺序，多线程的问题建议打印调试)</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/xq440m5q.html">&lbrack;数据库&rsqb;cakephp操作ENUM、tinyint等类型的一点说明</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8z4ejx9.html">Apache Nutch build文件解析</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qnk00gq.html">Java Log4j日志使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q24y7x8.html">iOS客户端的在线安装和更新&mdash;&mdash;针对ADHoc证书</a>
		</li>
						<li><a href="https://www.batexi.com/a/m96x4zy9.html">mustache&period;js</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9pz6oy8.html">PHP描述冒泡排序和快速排序算法</a>
		</li>
						<li><a href="https://www.batexi.com/a/96ojkm39.html">java面试每日一题13</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvnn21q.html">初探WebService</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1j2oyq.html">httpclient 学习</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnj40og8.html">Minix3信号处理分析</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rgr7om8.html">快速熟悉Oracle索引</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gevzo48.html">ScrollView与ListView嵌套使用，导致ListView下拉失效</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4zrje39.html">socket编程&colon;  TypeError&colon; must be bytes or buffer&comma; not str</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnj77pk8.html">Python开发【第四篇】函数</a>
		</li>
						<li><a href="https://www.batexi.com/a/90rdomn9.html">2018蓝桥杯 省赛B题&lpar;明码&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j1prn49.html">20165206 2017-2018-2 《Java程序设计》第8周学习总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jmkorl9.html">算法笔记&lowbar;038&colon;特殊回文数（Java）</a>
		</li>
						<li><a href="https://www.batexi.com/a/95prd4eq.html">MySQL多版本并发控制机制&lpar;MVCC&rpar;-源码浅析</a>
		</li>
						<li><a href="https://www.batexi.com/a/9je0nke8.html">PXE&lowbar;kickstart安装Ubuntu</a>
		</li>
						<li><a href="https://www.batexi.com/a/9g35wj7q.html">ActiveMQ 的管理和监控</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qy1z42mq.html">OPPO A3在哪里打开usb调试模式的详细教程</a>
			</li>
						<li><a href="https://www.batexi.com/a/90m6jyj8.html">OpenStack--Rabbitmq组件消息队列</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ojmvxeq.html">nginx代理 （带着请求头）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnjp5r28.html">jQuery概念</a>
			</li>
						<li><a href="https://www.batexi.com/a/8me1wjpq.html">docker 从入门到精通</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rgv61d8.html">Vue 2&period;6 中部分引入 TypeScript 的方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/90m6l7n8.html">C语言第零次作业</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdp7ldjq.html">五、OpenStack&mdash;nova组件介绍与安装</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlj675x9.html">【ABP&period;Net】2&period;多数据库支持&amp;amp&semi;&amp;amp&semi;初始化数据库</a>
			</li>
						<li><a href="https://www.batexi.com/a/9502yoz8.html">&lbrack;OC&rsqb; UIcollectionView 与 UIcollectionViewCell 的使用</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
